#ifndef _H_8B5F73D81D1D57C137D2D37CF2426E60_KinesisImageMetadata_DCPS_H_
#define _H_8B5F73D81D1D57C137D2D37CF2426E60_KinesisImageMetadata_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "KinesisImageMetadata_.h"


namespace kinesis_video_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class KinesisImageMetadata_TypeSupportInterface;

            typedef KinesisImageMetadata_TypeSupportInterface * KinesisImageMetadata_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < KinesisImageMetadata_TypeSupportInterface> KinesisImageMetadata_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < KinesisImageMetadata_TypeSupportInterface> KinesisImageMetadata_TypeSupportInterface_out;


            class KinesisImageMetadata_DataWriter;

            typedef KinesisImageMetadata_DataWriter * KinesisImageMetadata_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < KinesisImageMetadata_DataWriter> KinesisImageMetadata_DataWriter_var;
            typedef DDS_DCPSInterface_out < KinesisImageMetadata_DataWriter> KinesisImageMetadata_DataWriter_out;


            class KinesisImageMetadata_DataReader;

            typedef KinesisImageMetadata_DataReader * KinesisImageMetadata_DataReader_ptr;
            typedef DDS_DCPSInterface_var < KinesisImageMetadata_DataReader> KinesisImageMetadata_DataReader_var;
            typedef DDS_DCPSInterface_out < KinesisImageMetadata_DataReader> KinesisImageMetadata_DataReader_out;


            class KinesisImageMetadata_DataReaderView;

            typedef KinesisImageMetadata_DataReaderView * KinesisImageMetadata_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < KinesisImageMetadata_DataReaderView> KinesisImageMetadata_DataReaderView_var;
            typedef DDS_DCPSInterface_out < KinesisImageMetadata_DataReaderView> KinesisImageMetadata_DataReaderView_out;

            struct KinesisImageMetadata_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < KinesisImageMetadata_, struct KinesisImageMetadata_Seq_uniq_> KinesisImageMetadata_Seq;
            typedef DDS_DCPSSequence_var < KinesisImageMetadata_Seq> KinesisImageMetadata_Seq_var;
            typedef DDS_DCPSSequence_out < KinesisImageMetadata_Seq> KinesisImageMetadata_Seq_out;

            class  KinesisImageMetadata_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef KinesisImageMetadata_TypeSupportInterface_ptr _ptr_type;
                typedef KinesisImageMetadata_TypeSupportInterface_var _var_type;

                static KinesisImageMetadata_TypeSupportInterface_ptr _duplicate (KinesisImageMetadata_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisImageMetadata_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisImageMetadata_TypeSupportInterface_ptr _this () { return this; }


            protected:
                KinesisImageMetadata_TypeSupportInterface () {};
                ~KinesisImageMetadata_TypeSupportInterface () {};
            private:
                KinesisImageMetadata_TypeSupportInterface (const KinesisImageMetadata_TypeSupportInterface &);
                KinesisImageMetadata_TypeSupportInterface & operator = (const KinesisImageMetadata_TypeSupportInterface &);
            };

            class  KinesisImageMetadata_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef KinesisImageMetadata_DataWriter_ptr _ptr_type;
                typedef KinesisImageMetadata_DataWriter_var _var_type;

                static KinesisImageMetadata_DataWriter_ptr _duplicate (KinesisImageMetadata_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisImageMetadata_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisImageMetadata_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const KinesisImageMetadata_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const KinesisImageMetadata_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const KinesisImageMetadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const KinesisImageMetadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const KinesisImageMetadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const KinesisImageMetadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const KinesisImageMetadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const KinesisImageMetadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const KinesisImageMetadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const KinesisImageMetadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (KinesisImageMetadata_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KinesisImageMetadata_& instance_data) = 0;

            protected:
                KinesisImageMetadata_DataWriter () {};
                ~KinesisImageMetadata_DataWriter () {};
            private:
                KinesisImageMetadata_DataWriter (const KinesisImageMetadata_DataWriter &);
                KinesisImageMetadata_DataWriter & operator = (const KinesisImageMetadata_DataWriter &);
            };

            class  KinesisImageMetadata_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef KinesisImageMetadata_DataReader_ptr _ptr_type;
                typedef KinesisImageMetadata_DataReader_var _var_type;

                static KinesisImageMetadata_DataReader_ptr _duplicate (KinesisImageMetadata_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisImageMetadata_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisImageMetadata_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KinesisImageMetadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KinesisImageMetadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KinesisImageMetadata_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KinesisImageMetadata_& instance) = 0;

            protected:
                KinesisImageMetadata_DataReader () {};
                ~KinesisImageMetadata_DataReader () {};
            private:
                KinesisImageMetadata_DataReader (const KinesisImageMetadata_DataReader &);
                KinesisImageMetadata_DataReader & operator = (const KinesisImageMetadata_DataReader &);
            };

            class  KinesisImageMetadata_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef KinesisImageMetadata_DataReaderView_ptr _ptr_type;
                typedef KinesisImageMetadata_DataReaderView_var _var_type;

                static KinesisImageMetadata_DataReaderView_ptr _duplicate (KinesisImageMetadata_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisImageMetadata_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisImageMetadata_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisImageMetadata_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KinesisImageMetadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KinesisImageMetadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KinesisImageMetadata_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KinesisImageMetadata_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KinesisImageMetadata_& instance) = 0;

            protected:
                KinesisImageMetadata_DataReaderView () {};
                ~KinesisImageMetadata_DataReaderView () {};
            private:
                KinesisImageMetadata_DataReaderView (const KinesisImageMetadata_DataReaderView &);
                KinesisImageMetadata_DataReaderView & operator = (const KinesisImageMetadata_DataReaderView &);
            };
        }

    }

}

#endif
