#ifndef _H_D2BD332EC408A58F8456CF35D2819C35_KinesisVideoFrame_DCPS_H_
#define _H_D2BD332EC408A58F8456CF35D2819C35_KinesisVideoFrame_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "KinesisVideoFrame_.h"


namespace kinesis_video_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class KinesisVideoFrame_TypeSupportInterface;

            typedef KinesisVideoFrame_TypeSupportInterface * KinesisVideoFrame_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < KinesisVideoFrame_TypeSupportInterface> KinesisVideoFrame_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < KinesisVideoFrame_TypeSupportInterface> KinesisVideoFrame_TypeSupportInterface_out;


            class KinesisVideoFrame_DataWriter;

            typedef KinesisVideoFrame_DataWriter * KinesisVideoFrame_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < KinesisVideoFrame_DataWriter> KinesisVideoFrame_DataWriter_var;
            typedef DDS_DCPSInterface_out < KinesisVideoFrame_DataWriter> KinesisVideoFrame_DataWriter_out;


            class KinesisVideoFrame_DataReader;

            typedef KinesisVideoFrame_DataReader * KinesisVideoFrame_DataReader_ptr;
            typedef DDS_DCPSInterface_var < KinesisVideoFrame_DataReader> KinesisVideoFrame_DataReader_var;
            typedef DDS_DCPSInterface_out < KinesisVideoFrame_DataReader> KinesisVideoFrame_DataReader_out;


            class KinesisVideoFrame_DataReaderView;

            typedef KinesisVideoFrame_DataReaderView * KinesisVideoFrame_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < KinesisVideoFrame_DataReaderView> KinesisVideoFrame_DataReaderView_var;
            typedef DDS_DCPSInterface_out < KinesisVideoFrame_DataReaderView> KinesisVideoFrame_DataReaderView_out;

            struct KinesisVideoFrame_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < KinesisVideoFrame_, struct KinesisVideoFrame_Seq_uniq_> KinesisVideoFrame_Seq;
            typedef DDS_DCPSSequence_var < KinesisVideoFrame_Seq> KinesisVideoFrame_Seq_var;
            typedef DDS_DCPSSequence_out < KinesisVideoFrame_Seq> KinesisVideoFrame_Seq_out;

            class  KinesisVideoFrame_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef KinesisVideoFrame_TypeSupportInterface_ptr _ptr_type;
                typedef KinesisVideoFrame_TypeSupportInterface_var _var_type;

                static KinesisVideoFrame_TypeSupportInterface_ptr _duplicate (KinesisVideoFrame_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisVideoFrame_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisVideoFrame_TypeSupportInterface_ptr _this () { return this; }


            protected:
                KinesisVideoFrame_TypeSupportInterface () {};
                ~KinesisVideoFrame_TypeSupportInterface () {};
            private:
                KinesisVideoFrame_TypeSupportInterface (const KinesisVideoFrame_TypeSupportInterface &);
                KinesisVideoFrame_TypeSupportInterface & operator = (const KinesisVideoFrame_TypeSupportInterface &);
            };

            class  KinesisVideoFrame_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef KinesisVideoFrame_DataWriter_ptr _ptr_type;
                typedef KinesisVideoFrame_DataWriter_var _var_type;

                static KinesisVideoFrame_DataWriter_ptr _duplicate (KinesisVideoFrame_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisVideoFrame_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisVideoFrame_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const KinesisVideoFrame_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const KinesisVideoFrame_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const KinesisVideoFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const KinesisVideoFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const KinesisVideoFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const KinesisVideoFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const KinesisVideoFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const KinesisVideoFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const KinesisVideoFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const KinesisVideoFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (KinesisVideoFrame_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KinesisVideoFrame_& instance_data) = 0;

            protected:
                KinesisVideoFrame_DataWriter () {};
                ~KinesisVideoFrame_DataWriter () {};
            private:
                KinesisVideoFrame_DataWriter (const KinesisVideoFrame_DataWriter &);
                KinesisVideoFrame_DataWriter & operator = (const KinesisVideoFrame_DataWriter &);
            };

            class  KinesisVideoFrame_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef KinesisVideoFrame_DataReader_ptr _ptr_type;
                typedef KinesisVideoFrame_DataReader_var _var_type;

                static KinesisVideoFrame_DataReader_ptr _duplicate (KinesisVideoFrame_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisVideoFrame_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisVideoFrame_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KinesisVideoFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KinesisVideoFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KinesisVideoFrame_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KinesisVideoFrame_& instance) = 0;

            protected:
                KinesisVideoFrame_DataReader () {};
                ~KinesisVideoFrame_DataReader () {};
            private:
                KinesisVideoFrame_DataReader (const KinesisVideoFrame_DataReader &);
                KinesisVideoFrame_DataReader & operator = (const KinesisVideoFrame_DataReader &);
            };

            class  KinesisVideoFrame_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef KinesisVideoFrame_DataReaderView_ptr _ptr_type;
                typedef KinesisVideoFrame_DataReaderView_var _var_type;

                static KinesisVideoFrame_DataReaderView_ptr _duplicate (KinesisVideoFrame_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KinesisVideoFrame_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KinesisVideoFrame_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                KinesisVideoFrame_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KinesisVideoFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KinesisVideoFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KinesisVideoFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KinesisVideoFrame_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KinesisVideoFrame_& instance) = 0;

            protected:
                KinesisVideoFrame_DataReaderView () {};
                ~KinesisVideoFrame_DataReaderView () {};
            private:
                KinesisVideoFrame_DataReaderView (const KinesisVideoFrame_DataReaderView &);
                KinesisVideoFrame_DataReaderView & operator = (const KinesisVideoFrame_DataReaderView &);
            };
        }

    }

}

#endif
