// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kinesis_video_msgs:msg/KinesisVideoFrame.idl
// generated code does not contain a copyright notice

#ifndef KINESIS_VIDEO_MSGS__MSG__KINESIS_VIDEO_FRAME__STRUCT_H_
#define KINESIS_VIDEO_MSGS__MSG__KINESIS_VIDEO_FRAME__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'codec_private_data'
// Member 'frame_data'
#include "rosidl_generator_c/primitives_sequence.h"
// Member 'metadata'
#include "diagnostic_msgs/msg/key_value__struct.h"

// Struct defined in msg/KinesisVideoFrame in the package kinesis_video_msgs.
typedef struct kinesis_video_msgs__msg__KinesisVideoFrame
{
  uint32_t index;
  uint64_t decoding_ts;
  uint64_t presentation_ts;
  uint64_t duration;
  rosidl_generator_c__uint8__Sequence codec_private_data;
  rosidl_generator_c__uint8__Sequence frame_data;
  uint16_t flags;
  diagnostic_msgs__msg__KeyValue__Sequence metadata;
} kinesis_video_msgs__msg__KinesisVideoFrame;

// Struct for a sequence of kinesis_video_msgs__msg__KinesisVideoFrame.
typedef struct kinesis_video_msgs__msg__KinesisVideoFrame__Sequence
{
  kinesis_video_msgs__msg__KinesisVideoFrame * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kinesis_video_msgs__msg__KinesisVideoFrame__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KINESIS_VIDEO_MSGS__MSG__KINESIS_VIDEO_FRAME__STRUCT_H_
