// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kinesis_video_msgs:msg/KinesisVideoFrame.idl
// generated code does not contain a copyright notice

#ifndef KINESIS_VIDEO_MSGS__MSG__KINESIS_VIDEO_FRAME__STRUCT_HPP_
#define KINESIS_VIDEO_MSGS__MSG__KINESIS_VIDEO_FRAME__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'metadata'
#include "diagnostic_msgs/msg/key_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kinesis_video_msgs__msg__KinesisVideoFrame __attribute__((deprecated))
#else
# define DEPRECATED__kinesis_video_msgs__msg__KinesisVideoFrame __declspec(deprecated)
#endif

namespace kinesis_video_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct KinesisVideoFrame_
{
  using Type = KinesisVideoFrame_<ContainerAllocator>;

  explicit KinesisVideoFrame_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->index = 0ul;
      this->decoding_ts = 0ull;
      this->presentation_ts = 0ull;
      this->duration = 0ull;
      this->flags = 0;
    }
  }

  explicit KinesisVideoFrame_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->index = 0ul;
      this->decoding_ts = 0ull;
      this->presentation_ts = 0ull;
      this->duration = 0ull;
      this->flags = 0;
    }
  }

  // field types and members
  using _index_type =
    uint32_t;
  _index_type index;
  using _decoding_ts_type =
    uint64_t;
  _decoding_ts_type decoding_ts;
  using _presentation_ts_type =
    uint64_t;
  _presentation_ts_type presentation_ts;
  using _duration_type =
    uint64_t;
  _duration_type duration;
  using _codec_private_data_type =
    std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other>;
  _codec_private_data_type codec_private_data;
  using _frame_data_type =
    std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other>;
  _frame_data_type frame_data;
  using _flags_type =
    uint16_t;
  _flags_type flags;
  using _metadata_type =
    std::vector<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>, typename ContainerAllocator::template rebind<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>>::other>;
  _metadata_type metadata;

  // setters for named parameter idiom
  Type & set__index(
    const uint32_t & _arg)
  {
    this->index = _arg;
    return *this;
  }
  Type & set__decoding_ts(
    const uint64_t & _arg)
  {
    this->decoding_ts = _arg;
    return *this;
  }
  Type & set__presentation_ts(
    const uint64_t & _arg)
  {
    this->presentation_ts = _arg;
    return *this;
  }
  Type & set__duration(
    const uint64_t & _arg)
  {
    this->duration = _arg;
    return *this;
  }
  Type & set__codec_private_data(
    const std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other> & _arg)
  {
    this->codec_private_data = _arg;
    return *this;
  }
  Type & set__frame_data(
    const std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other> & _arg)
  {
    this->frame_data = _arg;
    return *this;
  }
  Type & set__flags(
    const uint16_t & _arg)
  {
    this->flags = _arg;
    return *this;
  }
  Type & set__metadata(
    const std::vector<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>, typename ContainerAllocator::template rebind<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>>::other> & _arg)
  {
    this->metadata = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator> *;
  using ConstRawPtr =
    const kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kinesis_video_msgs__msg__KinesisVideoFrame
    std::shared_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kinesis_video_msgs__msg__KinesisVideoFrame
    std::shared_ptr<kinesis_video_msgs::msg::KinesisVideoFrame_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const KinesisVideoFrame_ & other) const
  {
    if (this->index != other.index) {
      return false;
    }
    if (this->decoding_ts != other.decoding_ts) {
      return false;
    }
    if (this->presentation_ts != other.presentation_ts) {
      return false;
    }
    if (this->duration != other.duration) {
      return false;
    }
    if (this->codec_private_data != other.codec_private_data) {
      return false;
    }
    if (this->frame_data != other.frame_data) {
      return false;
    }
    if (this->flags != other.flags) {
      return false;
    }
    if (this->metadata != other.metadata) {
      return false;
    }
    return true;
  }
  bool operator!=(const KinesisVideoFrame_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct KinesisVideoFrame_

// alias to use template instance with default allocator
using KinesisVideoFrame =
  kinesis_video_msgs::msg::KinesisVideoFrame_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kinesis_video_msgs

#endif  // KINESIS_VIDEO_MSGS__MSG__KINESIS_VIDEO_FRAME__STRUCT_HPP_
