#ifndef _H_D2BD332EC408A58F8456CF35D2819C35_KinesisVideoFrame__H_
#define _H_D2BD332EC408A58F8456CF35D2819C35_KinesisVideoFrame__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "diagnostic_msgs/msg/dds_opensplice/KeyValue_.h"


namespace kinesis_video_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  KinesisVideoFrame_
            {
                struct _codec_private_data__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Octet, struct _codec_private_data__seq_uniq_ > _codec_private_data__seq;
                typedef DDS_DCPSSequence_var< _codec_private_data__seq > _codec_private_data__seq_var;
                typedef DDS_DCPSSequence_out< _codec_private_data__seq > _codec_private_data__seq_out;
                struct _frame_data__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Octet, struct _frame_data__seq_uniq_ > _frame_data__seq;
                typedef DDS_DCPSSequence_var< _frame_data__seq > _frame_data__seq_var;
                typedef DDS_DCPSSequence_out< _frame_data__seq > _frame_data__seq_out;
                struct _metadata__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::diagnostic_msgs::msg::dds_::KeyValue_, struct _metadata__seq_uniq_ > _metadata__seq;
                typedef DDS_DCPSSequence_var< _metadata__seq > _metadata__seq_var;
                typedef DDS_DCPSSequence_out< _metadata__seq > _metadata__seq_out;
                ::DDS::ULong index_;
                ::DDS::ULongLong decoding_ts_;
                ::DDS::ULongLong presentation_ts_;
                ::DDS::ULongLong duration_;
                _codec_private_data__seq codec_private_data_;
                _frame_data__seq frame_data_;
                ::DDS::UShort flags_;
                _metadata__seq metadata_;
            };

            typedef DDS_DCPSStruct_var<KinesisVideoFrame_> KinesisVideoFrame__var;
            typedef DDS_DCPSStruct_out < KinesisVideoFrame_> KinesisVideoFrame__out;

        }

    }

}

#endif /* _H_D2BD332EC408A58F8456CF35D2819C35_KinesisVideoFrame__H_ */
