// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kinesis_video_msgs:msg/KinesisImageMetadata.idl
// generated code does not contain a copyright notice

#ifndef KINESIS_VIDEO_MSGS__MSG__KINESIS_IMAGE_METADATA__FUNCTIONS_H_
#define KINESIS_VIDEO_MSGS__MSG__KINESIS_IMAGE_METADATA__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "kinesis_video_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "kinesis_video_msgs/msg/kinesis_image_metadata__struct.h"

/// Initialize msg/KinesisImageMetadata message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * kinesis_video_msgs__msg__KinesisImageMetadata
 * )) before or use
 * kinesis_video_msgs__msg__KinesisImageMetadata__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
bool
kinesis_video_msgs__msg__KinesisImageMetadata__init(kinesis_video_msgs__msg__KinesisImageMetadata * msg);

/// Finalize msg/KinesisImageMetadata message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
void
kinesis_video_msgs__msg__KinesisImageMetadata__fini(kinesis_video_msgs__msg__KinesisImageMetadata * msg);

/// Create msg/KinesisImageMetadata message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * kinesis_video_msgs__msg__KinesisImageMetadata__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
kinesis_video_msgs__msg__KinesisImageMetadata *
kinesis_video_msgs__msg__KinesisImageMetadata__create();

/// Destroy msg/KinesisImageMetadata message.
/**
 * It calls
 * kinesis_video_msgs__msg__KinesisImageMetadata__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
void
kinesis_video_msgs__msg__KinesisImageMetadata__destroy(kinesis_video_msgs__msg__KinesisImageMetadata * msg);


/// Initialize array of msg/KinesisImageMetadata messages.
/**
 * It allocates the memory for the number of elements and calls
 * kinesis_video_msgs__msg__KinesisImageMetadata__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
bool
kinesis_video_msgs__msg__KinesisImageMetadata__Sequence__init(kinesis_video_msgs__msg__KinesisImageMetadata__Sequence * array, size_t size);

/// Finalize array of msg/KinesisImageMetadata messages.
/**
 * It calls
 * kinesis_video_msgs__msg__KinesisImageMetadata__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
void
kinesis_video_msgs__msg__KinesisImageMetadata__Sequence__fini(kinesis_video_msgs__msg__KinesisImageMetadata__Sequence * array);

/// Create array of msg/KinesisImageMetadata messages.
/**
 * It allocates the memory for the array and calls
 * kinesis_video_msgs__msg__KinesisImageMetadata__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
kinesis_video_msgs__msg__KinesisImageMetadata__Sequence *
kinesis_video_msgs__msg__KinesisImageMetadata__Sequence__create(size_t size);

/// Destroy array of msg/KinesisImageMetadata messages.
/**
 * It calls
 * kinesis_video_msgs__msg__KinesisImageMetadata__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kinesis_video_msgs
void
kinesis_video_msgs__msg__KinesisImageMetadata__Sequence__destroy(kinesis_video_msgs__msg__KinesisImageMetadata__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // KINESIS_VIDEO_MSGS__MSG__KINESIS_IMAGE_METADATA__FUNCTIONS_H_
