// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kinesis_video_msgs:msg/KinesisImageMetadata.idl
// generated code does not contain a copyright notice

#ifndef KINESIS_VIDEO_MSGS__MSG__KINESIS_IMAGE_METADATA__STRUCT_HPP_
#define KINESIS_VIDEO_MSGS__MSG__KINESIS_IMAGE_METADATA__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'metadata'
#include "diagnostic_msgs/msg/key_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kinesis_video_msgs__msg__KinesisImageMetadata __attribute__((deprecated))
#else
# define DEPRECATED__kinesis_video_msgs__msg__KinesisImageMetadata __declspec(deprecated)
#endif

namespace kinesis_video_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct KinesisImageMetadata_
{
  using Type = KinesisImageMetadata_<ContainerAllocator>;

  explicit KinesisImageMetadata_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit KinesisImageMetadata_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _metadata_type =
    std::vector<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>, typename ContainerAllocator::template rebind<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>>::other>;
  _metadata_type metadata;

  // setters for named parameter idiom
  Type & set__metadata(
    const std::vector<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>, typename ContainerAllocator::template rebind<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>>::other> & _arg)
  {
    this->metadata = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator> *;
  using ConstRawPtr =
    const kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kinesis_video_msgs__msg__KinesisImageMetadata
    std::shared_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kinesis_video_msgs__msg__KinesisImageMetadata
    std::shared_ptr<kinesis_video_msgs::msg::KinesisImageMetadata_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const KinesisImageMetadata_ & other) const
  {
    if (this->metadata != other.metadata) {
      return false;
    }
    return true;
  }
  bool operator!=(const KinesisImageMetadata_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct KinesisImageMetadata_

// alias to use template instance with default allocator
using KinesisImageMetadata =
  kinesis_video_msgs::msg::KinesisImageMetadata_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kinesis_video_msgs

#endif  // KINESIS_VIDEO_MSGS__MSG__KINESIS_IMAGE_METADATA__STRUCT_HPP_
