// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kinesis_video_msgs:msg/KinesisVideoFrame.idl
// generated code does not contain a copyright notice
#include "kinesis_video_msgs/msg/kinesis_video_frame__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `codec_private_data`
// Member `frame_data`
#include "rosidl_generator_c/primitives_sequence_functions.h"
// Member `metadata`
#include "diagnostic_msgs/msg/key_value__functions.h"

bool
kinesis_video_msgs__msg__KinesisVideoFrame__init(kinesis_video_msgs__msg__KinesisVideoFrame * msg)
{
  if (!msg) {
    return false;
  }
  // index
  // decoding_ts
  // presentation_ts
  // duration
  // codec_private_data
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->codec_private_data, 0)) {
    kinesis_video_msgs__msg__KinesisVideoFrame__fini(msg);
    return false;
  }
  // frame_data
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->frame_data, 0)) {
    kinesis_video_msgs__msg__KinesisVideoFrame__fini(msg);
    return false;
  }
  // flags
  // metadata
  if (!diagnostic_msgs__msg__KeyValue__Sequence__init(&msg->metadata, 0)) {
    kinesis_video_msgs__msg__KinesisVideoFrame__fini(msg);
    return false;
  }
  return true;
}

void
kinesis_video_msgs__msg__KinesisVideoFrame__fini(kinesis_video_msgs__msg__KinesisVideoFrame * msg)
{
  if (!msg) {
    return;
  }
  // index
  // decoding_ts
  // presentation_ts
  // duration
  // codec_private_data
  rosidl_generator_c__uint8__Sequence__fini(&msg->codec_private_data);
  // frame_data
  rosidl_generator_c__uint8__Sequence__fini(&msg->frame_data);
  // flags
  // metadata
  diagnostic_msgs__msg__KeyValue__Sequence__fini(&msg->metadata);
}

kinesis_video_msgs__msg__KinesisVideoFrame *
kinesis_video_msgs__msg__KinesisVideoFrame__create()
{
  kinesis_video_msgs__msg__KinesisVideoFrame * msg = (kinesis_video_msgs__msg__KinesisVideoFrame *)malloc(sizeof(kinesis_video_msgs__msg__KinesisVideoFrame));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kinesis_video_msgs__msg__KinesisVideoFrame));
  bool success = kinesis_video_msgs__msg__KinesisVideoFrame__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
kinesis_video_msgs__msg__KinesisVideoFrame__destroy(kinesis_video_msgs__msg__KinesisVideoFrame * msg)
{
  if (msg) {
    kinesis_video_msgs__msg__KinesisVideoFrame__fini(msg);
  }
  free(msg);
}


bool
kinesis_video_msgs__msg__KinesisVideoFrame__Sequence__init(kinesis_video_msgs__msg__KinesisVideoFrame__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  kinesis_video_msgs__msg__KinesisVideoFrame * data = NULL;
  if (size) {
    data = (kinesis_video_msgs__msg__KinesisVideoFrame *)calloc(size, sizeof(kinesis_video_msgs__msg__KinesisVideoFrame));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kinesis_video_msgs__msg__KinesisVideoFrame__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kinesis_video_msgs__msg__KinesisVideoFrame__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kinesis_video_msgs__msg__KinesisVideoFrame__Sequence__fini(kinesis_video_msgs__msg__KinesisVideoFrame__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kinesis_video_msgs__msg__KinesisVideoFrame__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kinesis_video_msgs__msg__KinesisVideoFrame__Sequence *
kinesis_video_msgs__msg__KinesisVideoFrame__Sequence__create(size_t size)
{
  kinesis_video_msgs__msg__KinesisVideoFrame__Sequence * array = (kinesis_video_msgs__msg__KinesisVideoFrame__Sequence *)malloc(sizeof(kinesis_video_msgs__msg__KinesisVideoFrame__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = kinesis_video_msgs__msg__KinesisVideoFrame__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
kinesis_video_msgs__msg__KinesisVideoFrame__Sequence__destroy(kinesis_video_msgs__msg__KinesisVideoFrame__Sequence * array)
{
  if (array) {
    kinesis_video_msgs__msg__KinesisVideoFrame__Sequence__fini(array);
  }
  free(array);
}
